import java.util.Vector;import java.util.Vector;

import java.lang.Math.*;

/**
 * Class which implements the interface Grid. 
 * Class enabling the case of a square plane grid
 */
public class SquareGrid implements Grid {

    private Cell root;

    private int dimx;
    private int dimy;

    private Vector listCells;

    /**
     * Constructor of SquareGrid. The grid will contain (size)² cells.
     * @param size resolution upon Ox and Oy. 
     */
    public SquareGrid(int size){

	Point proot = new Point(0,0,0,0);
	root = new Cell(proot,"square");
	double probroot = 1.0/((double)(size*size));

	dimx = size;
	dimy = size;

	listCells = new Vector();

	// on cree toutes les cellules	
	for (int j=1; j<= dimy; j++){
			
	    //int index = 1

	    for (int i=1; i<=dimx; i++){

		Point p = new Point(i,j,0,0);
				
		Cell temp = new Cell(p,"square");
		listCells.addElement(temp);
		root.addNeighbour(temp,probroot);
	    }

		
	}


	// on associe toutes les cellules a leurs voisin respectifs
	for (int j=1; j<= dimy; j++){

	    for (int i=1; i<= dimx; i++){

		Cell temp = this.getCell(i,j);

		// Classement
		if (j==dimy) {
		    temp.addNeighbour(this.getCell(i,1), 0.25);
		} 
		else {
		    temp.addNeighbour(this.getCell(i,j+1), 0.25);
		}


		if (i==1) {
		    temp.addNeighbour(this.getCell(dimx,j), 0.25);
		} 
		else {
		    temp.addNeighbour(this.getCell(i-1,j), 0.25);
		}


		if (j==1) {
		    temp.addNeighbour(this.getCell(i,dimy), 0.25);
		} 
		else {
		    temp.addNeighbour(this.getCell(i,j-1), 0.25);
		}


		if (i==dimx) {
		    temp.addNeighbour(this.getCell(1,j), 0.25);
		} 
		else {
		    temp.addNeighbour(this.getCell(i+1,j), 0.25);
		}
		
	    }
	}


	// on determine le diagramme de Voronoi
	for (int j=1; j<= dimy; j++){

	    for (int i=1; i<= dimx; i++){
		Cell temp = this.getCell(i,j);
		
		temp.generateVoronoi();
		
	    }
	}

	// On entre les probas d'arrive

	double proba =  1. / (dimy * dimx);
	for (int j=1; j<= dimy; j++){

	    for (int i=1; i<= dimx; i++){
		Cell temp = this.getCell(i,j);
		
		temp.setArrival(proba);
		
	    }
	}


    }


    /**
     * Returns a specific Cell from the grid. The desired Cell is specified via its cartesian coordinates.
     * @param x abscissa of the desired Cell 
     * @param y ordinate of the desired Cell 
     * @return desired Cell
     */
    public Cell getCell(int x, int y){

	int index = (y-1) * dimx + x - 1;

	return (Cell)(listCells.elementAt(index));  

    }

    


    /**
     * Getter for the attribut "listCells"
     * @return listCells
     */
    public Vector getCells(){

	return listCells;

    }




    /**
     * Getter for the attribut "root"
     * @return root
     */
    public Cell getRoot(){

	return root;

    }


    /**
     * Returns the x y coordinates of the cell
     */
    public Vector projec(Cell c){

	Vector temp = new Vector();
	Vector coord = c.getCartCoordinates();
	
	temp.addElement(coord.elementAt(0));
	temp.addElement(coord.elementAt(1));

	return temp;

    }

}
